//----------------------------------------------------------------------------------------


void MMove(int xx,int yy){
  printf("M%d;%d;\n",xx,yy) ;
  }
  
void DDraw(int xx, int yy){  
  printf("D%d;%d;\n",xx,yy) ;
  }

void LLine(int xx1, int yy1, int xx, int yy){  
 printf("L%d;%d;%d;%d;\n",xx1,yy1,xx,yy) ;
 }

 void BLine(int xx1, int yy1, int xx, int yy, int m){  
 printf("K%d;%d;%d;%d;%d;\n",xx1,yy1,xx,yy,m) ;
 }
  
void SStroke(int rr, int gg, int bb){
  printf("S%d;%d;%d;\n",rr,gg,bb) ;
  }
  
void TText(char* tt){
  printf("T%c%s%c\n",'"',tt,'"') ;  
  }

void PPrint(){
  printf("P\n") ;  
  }  



//----------------------------------------------------------------------------------------
#define xSize 1000
#define ySize 800

#define dd 5 
#define phSize 200 
int ee=ySize-phSize ;

#define vectorPlot 0
#define gainPhasePlot 1

float fMin=40 ;
float fMax=62.5e3 ;

float gMax=1.4 ;
float gMin=0.007 ;
//float gMin=0.0001 ;

float pMax=180+20 ;
float pMin=-180-20 ;

/*float log10(float x){
  return (float)Math.log10(x) ;
  }
*/

int IQxx(float x){
  return(400+300*x) ;
  }

int IQyy(float y){
  return(400-300*y) ;
  }  

float logx(float f){
  return log10(f) ;
  }

int xOfF(float f){
  if(f<fMin){ f=fMin ; }
  if(f>fMax) { f=fMax ; }
  
  return (int)( dd+(xSize-2*dd)*(logx(f)-logx(fMin))/(logx(fMax)-logx(fMin)) ) ;
  }
  
float dBg(float g){
  return 20.0*log10(g) ;
}

int yOfG(float g){
  if(g<gMin){ g=gMin ; }
  if(g>gMax){ g=gMax ; }
  return (int)( ee-(ee-dd)*(dBg(g)-dBg(gMin))/(dBg(gMax)-dBg(gMin)) );
  }
  
int yOfP(float p){
  if(p<pMin){ p=pMin ; }
  if(p>pMax){ p=pMax ; }
  return (int)( ySize-dd-(phSize)*(p-pMin)/(pMax-pMin) );
  }
  
  

void yLine(float f){
  int xx=xOfF(f) ;
  //LLine(xx,dd,xx,ySize-dd) ;
  BLine(xx,dd,xx,ySize-dd,15) ;
  }
  
void xLineG(float g){
  int yy=yOfG(g) ;
  //LLine(xx,dd,xx,ySize-dd) ;
  BLine(dd,yy,xSize-dd,yy,15) ;
  }  

void xLineP(float p){
  int yy=yOfP(p) ;
  //LLine(xx,dd,xx,ySize-dd) ;
  BLine(dd,yy,xSize-dd,yy,15) ;
  }  
  
void grFrame(){
  SStroke(255,0,0) ; 
  MMove(dd,dd) ;
  DDraw(xSize-dd,dd) ;
  DDraw(xSize-dd,ySize-dd) ;
  DDraw(dd,ySize-dd) ;
  DDraw(dd,dd) ;
  
  if(gainPhasePlot){
    LLine(dd,ee,xSize-dd,ee) ;
    SStroke(0,0,255) ;
    // LLine(xOfF(fMin),300,xOfF(fMax),300) ;
    // LLine(200,yOfG(gMin),200,yOfG(gMax)) ;

    yLine(50) ; MMove(xOfF(50)+2,ee-3) ; TText("50") ;
    yLine(100) ; MMove(xOfF(100)+2,ee-3) ; TText("100") ;

    yLine(200) ; MMove(xOfF(200)+2,ee-3) ; TText("200") ;
    yLine(500) ; MMove(xOfF(500)+2,ee-3) ; TText("500") ;
    yLine(1000) ; MMove(xOfF(1000)+2,ee-3) ; TText("1k") ;
    yLine(2000) ; MMove(xOfF(2000)+2,ee-3) ; TText("2k") ;
    yLine(5000) ; MMove(xOfF(5000)+2,ee-3) ; TText("5k") ;
    yLine(10000) ;  MMove(xOfF(10000)+2,ee-3) ; TText("10k") ;
    yLine(20000) ;  MMove(xOfF(20000)+2,ee-3) ; TText("20k") ;
    yLine(50000) ;  MMove(xOfF(50000)+2,ee-3) ; TText("50k") ;

    xLineG(1.0) ;  MMove(dd+2,yOfG(1.0)-3) ; TText("0 dB") ;
    xLineG(0.1) ; MMove(dd+2,yOfG(0.1)-3) ; TText("-10 dB") ;
    xLineG(0.01) ;MMove(dd+2,yOfG(0.01)-3) ; TText("-20 dB") ;
    //xLineG(0.001) ;MMove(dd+2,yOfG(0.001)-3) ; TText("-30 dB") ;
  
    xLineP(0.0) ;  MMove(dd+2,yOfP(1.0)-3) ; TText("0") ;
    xLineP(180.0) ;  MMove(dd+2,yOfP(180.0)+23) ; TText("180") ;
    xLineP(-180.0) ;  MMove(dd+2,yOfP(-180.0)-3) ; TText("-180") ;
    }

  if(vectorPlot){
     SStroke(255,0,255) ;
    LLine(IQxx(-1.2),IQyy(0),IQxx(1.2),IQyy(0)) ;
    LLine(IQxx(1.2-0.05),IQyy(0.05),IQxx(1.2),IQyy(0)) ;
    LLine(IQxx(1.2-0.05),IQyy(-0.05),IQxx(1.2),IQyy(0)) ;
    LLine(IQxx(1.0),IQyy(-0.05),IQxx(1.0),IQyy(0.05)) ;
    MMove(IQxx(1.05),IQyy(-0.05)) ; TText("1") ;
    MMove(IQxx(1.25),IQyy(-0.05)) ; TText("I") ;

    LLine(IQxx(0),IQyy(-1.2),IQxx(0),IQyy(1.2)) ;
    LLine(IQxx(-0.05),IQyy(1.2-0.05),IQxx(0),IQyy(1.2)) ;
    LLine(IQxx( 0.05),IQyy(1.2-0.05),IQxx(0),IQyy(1.2)) ;
    LLine(IQxx(-0.05),IQyy(1.0),IQxx(0.05),IQyy(1.0)) ;
    MMove(IQxx(0.05),IQyy(1.0)) ; TText("1") ;
    MMove(IQxx(0.05),IQyy(1.2)) ; TText("Q") ;
    }
  }

//----------------------------------------------------------------------------------------
