
#include "pico/stdlib.h"
#include <stdio.h>
#include <math.h>

#include "pico/time.h"
#include "hardware/irq.h"
#include "hardware/structs/adc.h"
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_pwm\include\hardware\pwm.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_adc\include\hardware\adc.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_gpio\include\hardware\gpio.h>
//#include "hardware/adc.h"

#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_sync\include\hardware\sync.h>

#include "hardware/resets.h"
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_spi\include\hardware\spi.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_spi\spi.c>


#define PWM_PIN1 2
#define PWM_PIN2 3

#define fSampleADC 500000

#define GPIO4 4
int toggle ;
volatile int TFTsync=0 ;
#define tftOn 1
#define termOn 1


uint32_t DDSp ; // DDS phase value
uint32_t DDSd ; // DDS phase delta


// BBC 198kHz +/- 22.5 degrees 25 bit/sec

int sintab[256] ;
int LOsinTab[256] ;
int LOcosTab[256] ;

int demodFil ;
int IIfil ;
int QQfil ;

int fPWM ;

//-----------------------------------------------------------------------------------

#define tftOn 1

// Color definitions
#define ILI9341_BLACK       0x0000      /*   0,   0,   0 */
#define ILI9341_NAVY        0x000F      /*   0,   0, 128 */
#define ILI9341_DARKGREEN   0x03E0      /*   0, 128,   0 */
#define ILI9341_DARKCYAN    0x03EF      /*   0, 128, 128 */
#define ILI9341_MAROON      0x7800      /* 128,   0,   0 */
#define ILI9341_PURPLE      0x780F      /* 128,   0, 128 */
#define ILI9341_OLIVE       0x7BE0      /* 128, 128,   0 */
#define ILI9341_LIGHTGREY   0xC618      /* 192, 192, 192 */
#define ILI9341_DARKGREY    0x7BEF      /* 128, 128, 128 */
#define ILI9341_BLUE        0x001F      /*   0,   0, 255 */
#define ILI9341_GREEN       0x07E0      /*   0, 255,   0 */
#define ILI9341_CYAN        0x07FF      /*   0, 255, 255 */
#define ILI9341_RED         0xF800      /* 255,   0,   0 */
#define ILI9341_MAGENTA     0xF81F      /* 255,   0, 255 */
#define ILI9341_YELLOW      0xFFE0      /* 255, 255,   0 */
#define ILI9341_WHITE       0xFFFF      /* 255, 255, 255 */
#define ILI9341_ORANGE      0xFD20      /* 255, 165,   0 */
#define ILI9341_GREENYELLOW 0xAFE5      /* 173, 255,  47 */
#define ILI9341_PINK        0xF81F

int chrColor = ILI9341_WHITE ; 
int chrBackground = ILI9341_BLACK ; 
int xLast=0 ;
int yLast=0 ;




//-----------------------------------------------------------------------------------

static void approxSleepUs(int n){
  for(int k=0 ; k<n ; k++){
    for( int kk=0 ; kk<5 ; kk++){
      asm volatile("nop");
      }
    }
  }
  
static void approxSleepMs(int n){
  for(int k=0 ; k<n ; k++){
    for( int kk=0 ; kk<10 ; kk++){
      approxSleepUs(1000) ;
      }
    }
  }

static volatile void approxSleepUsTest(){
  printf("atleastSleepUsTest()\n") ;
  save_and_disable_interrupts() ;
  while(1){
    sio_hw->gpio_set =(1ul << GPIO4) ;  
	  approxSleepUs(1000) ;
    //sleep_ms(1) ;
    sio_hw->gpio_clr =(1ul << GPIO4) ;  
    approxSleepUs(1000) ;
  //  printf(".") ;
  }
} 

#include "tftLib1.c"

//-----------------------------------------------------------------------------------

#define maxsec 50 
#define maxfil 10 

float a0[maxfil]  ;
int secstart[maxfil] ;
int seccnt[maxfil] ;

float w1[maxsec] ;

float w2[maxsec] ;
float a1[maxsec] ;
float a2[maxsec] ;
float b1[maxsec] ;
float b2[maxsec] ;
int filtop=0 ;
int sectop=0  ;

int butter(int nord, float frq){
int i,nsec ; 
float a0x,eps,a,b,s1,s2,t,c1,w,ww,u,v,d ;

if ((nord % 2)!=0){ printf("nord wrong in Tscheby") ; }
filtop++ ;
if( filtop>maxfil){ printf("maxfil error") ; }
nsec=nord / 2 ;
secstart[filtop]=sectop+1 ;
seccnt[filtop]=nsec ;
printf("butterworth filter, no=%d\n",filtop) ;
printf("ord=%d number of sections is %d\n",nord,nsec) ;
a0x=1.0 ;
for( i=nord ; i< 3*nsec ; i++){
  t=(2.0*i+1.0)/(2.0*nord)*M_PI ;
  c1=M_PI*frq ;
  w=sin(c1)/cos(c1) ;
  printf("t=%10.4f  w=%10.4f\n",t,w) ;
  ww=w*w ;
  b=2*w ;
  d=1-b*cos(t)+ww ;
  u=(1-ww)/d ;
  v=b*sin(t)/d ;
  sectop++ ;
  b1[sectop]=-2*u ;
  b2[sectop]=u*u+v*v ;
  printf("b1=%10.4f b2=%10.4f\n",b1[sectop],b2[sectop]) ;
  a1[sectop]=2 ; 
  a2[sectop]=1 ;
  a0x=a0x*(1-2*u+u*u+v*v)/4 ;
  }
printf("a0=%10.4f\n",a0x) ;
a0[filtop]=a0x ;
return filtop ;
}

void tpreset(int filno){ 
  int i ;
  printf("reset filter with no=%d\n",filno) ;
  for (i=secstart[filno] ; i<secstart[filno]+seccnt[filno] ; i++){
  w1[i]=0 ; 
  w2[i]=0 ; 
  printf("clear section %d\n",i) ;
  }
}

float tprun(int filno, float x){
  int i ; 
  float w,w11,w22,y ;
  for(i=secstart[filno] ; i< secstart[filno]+seccnt[filno] ; i++){
    w11=w1[i] ; w22=w2[i] ;
    w=x-b1[i]*w11-b2[i]*w22 ;
    y=w+a1[i]*w11+a2[i]*w22 ;
    w2[i]=w11 ; w1[i]=w ; x=y ;
    }
  return a0[filno]*y ;
  }

//---------------------------------------------------------------

void uart_putc1(char c){
  printf("%c",c) ;
 // termPutc(c) ;
  }

void uart_puts1 (char *s){
  while (*s){   
    uart_putc1(*s);
    s++;
    }
  }

void uart_blank(){
  uart_putc1(' ') ; 
  }

void uart_crlf(){
  uart_putc1(13) ; 
  uart_putc1(10) ;
  }

void uart_cr(){
  uart_putc1(13) ; 
  uart_putc1(10) ;
  }

void decout(int k){
  // uart_putc1(32) ;
  uart_putc1( ((k/1000) % 10)+48 ) ;
  uart_putc1( ((k/100) % 10)+48 ) ;
  uart_putc1( ((k/10) % 10)+48 ) ;
  uart_putc1( (k % 10)+48 ) ;
  uart_putc1(32) ;
  }

void chr_out(uint8_t v){
  uart_putc1(v) ; 
  }

void hex_out(uint8_t v){
  v &=0b00001111 ;
  if (v<=9) { chr_out('0'+v) ; } 
    else { chr_out(v+'A'-10) ; } ;
  }

void byte_out(uint8_t v){
  hex_out(v>>4) ; 
  hex_out(v) ; 
  }

void word_out(uint16_t v){
  byte_out(v>>8) ; 
  byte_out(v) ; 
  }

//------------------------------------------------------------------------------------------------------
#define scopeXsize 300
#define scopeYsize 100
#define scopeX0 10
#define scopeY0 10
#define scopeColor  ILI9341_WHITE 
#define scopeBackground  ILI9341_DARKGREEN 

int scopeX ;
int scopeYi[scopeXsize] ;

void scopeInit(){
  tftRectf(scopeX0, scopeY0, scopeXsize, scopeYsize, scopeBackground ) ;
  scopeX=0 ;
  for(int k=0 ; k<scopeXsize ; k++){
    scopeYi[k]=0 ;
    }
  }

void doScope(int y){
  //zzz
  //return ;
  static int lastY=0 ;
  if(y<0){ y=0 ; }
  if(y>=scopeYsize){ y=scopeYsize-1 ; }
  y += scopeY0 ;
  if(scopeX>0){
    tftLine(scopeX0+scopeX-1,lastY,scopeX0+scopeX,scopeYi[scopeX],scopeBackground) ;
    tftLine(scopeX0+scopeX-1,scopeYi[scopeX-1],scopeX0+scopeX,y,scopeColor) ;
    }
  lastY=scopeYi[scopeX] ;
  scopeYi[scopeX]=y ;
  scopeX++ ;
  if(scopeX>=scopeXsize){ scopeX=0 ; }
  }

//------------------------------------------------------------------------------------------------------


int sampleTime=0 ;
int Isum,Qsum ;
static volatile int Ival,Qval ;

#define IntFifoSize 16384
#define IntFifoMask (16384-1)

volatile int IntFifoInPtr ;
volatile int IntFifoOutPtr ;
volatile int16_t IntFifoI[IntFifoSize] ;
volatile int16_t IntFifoQ[IntFifoSize] ;

void IntFifoInit(){
  IntFifoInPtr=0 ;
  IntFifoOutPtr=0 ;
  }

int inputVal ;
int pwm=0 ;

void on_pwm_wrap() {
  gpio_put(GPIO4, 1);
  pwm_clear_irq(pwm_gpio_to_slice_num(PWM_PIN1));
  while(adc_fifo_get_level()){
    DDSp += DDSd ; 
    inputVal=(adc_fifo_get()-2048) ;
    Isum += LOsinTab[DDSp>>24]*inputVal ;
    Qsum += LOcosTab[DDSp>>24]*inputVal ;
    sampleTime++ ;
    if(sampleTime>=1250){ 
      Ival=Isum/256 ; 
      Qval=Qsum/256 ;
      Isum=0 ;
      Qsum=0 ;
      sampleTime=0 ;
      IntFifoI[IntFifoInPtr]=Ival ;
      IntFifoQ[IntFifoInPtr]=Qval ;
      IntFifoInPtr=(IntFifoInPtr+1) & IntFifoMask ;
      }
    }  
  gpio_put(GPIO4, 0);
  }

//----------------------------------------------------------------------------------------

int SRgt,SRww1,SRww2,SRcrc,SRsyn ;
int local_time , synced_time , sync_point;

int seconds ;

int sync_message,sync_fifo0,sync_fifo1,sync_fifo2 ;

void start_syndrom(){
  SRgt=0 ; 
  SRww1=0 ; 
  SRww2=0 ; 
  SRcrc=0 ; 
  SRsyn=0 ;
  local_time= 0 ;
  synced_time=0 ;
  sync_point=0 ;
  seconds=0 ;
  }

 void sm_do(int8_t sm){ 
  sm= local_time-sm ;
  if (sm<0) { sm+=50 ; }
  uart_putc1('S') ; decout(sm) ;
  sync_fifo0=sync_fifo1 ; 
  sync_fifo1=sync_fifo2 ; 
  sync_fifo2=sm ;
  if ( (sync_fifo0==sync_fifo1) && (sync_fifo1==sync_fifo2) ) { 
	  sync_point=sync_fifo0 ; 
    }
  }

int tftPos1=0 ;

void timeGroup(){
  uart_puts1("time: ") ;
  hex_out(SRgt) ; uart_blank() ;
  word_out(SRww1) ; uart_blank() ;
  word_out(SRww2) ; uart_blank() ;
	//uart_cr() ;  
  int hours ;
	hours=(SRww2>>12) & 0xf ;
	if (SRww1 & 1) { hours+=16 ; }
  decout(hours) ; uart_putc1(':') ;
	int minutes=( SRww2>>6 ) & 0x3F ; decout(minutes) ;
  int offset= SRww2 & 0x3F ;
  if((offset & 0x20)!=0){ offset |= 0xFFFFFFC0 ; }
  uart_puts1(" offset=") ; decout(offset) ;
  seconds=0 ;
  //uart_cr() ; 
  int week=( SRww1>>4 ) & 0x3F ; uart_puts1(" week=") ; decout(week) ;
	//uart_cr() ; 
  int day=( SRww1>>1 ) & 0x7 ; uart_puts1(" day=") ; decout(day) ;
  if (day==1) { uart_puts1("monday" ) ; }
  if (day==2) { uart_puts1("tuesday" ) ; }
  if (day==3) { uart_puts1("wednesday" ) ; }
  if (day==4) { uart_puts1("thursday" ) ; }
	if (day==5) { uart_puts1("friday") ; }
	if (day==6) { uart_puts1("saturday" ) ; }
  if (day==7) { uart_puts1("sunday" ) ; } 
  uart_cr() ; 
  //zzz
  cursorY=115 ;
  cursorX=20 ;
  tftPrint("t:") ;
  tftDecout2(hours) ;
  tftPutc(':') ;
  tftDecout2(minutes) ;
  tftPutc(':') ;
  tftDecout2(seconds) ;
  tftPrint(" week ") ;
  tftDecout2(week) ;
  tftPutc(' ') ;
  if (day==1) { tftPrint("monday" ) ; }
  if (day==2) { tftPrint("tuesday" ) ; }
  if (day==3) { tftPrint("wednesday" ) ; }
  if (day==4) { tftPrint("thursday" ) ; }
	if (day==5) { tftPrint("friday") ; }
	if (day==6) { tftPrint("saturday" ) ; }
  if (day==7) { tftPrint("sunday" ) ; } 
  }

void groupDecode(){
  //return ;
  // if ( (SRgt&0xf) != 0 ) {
  hex_out(SRgt) ; uart_blank() ;
  word_out(SRww1) ; uart_blank() ;
  word_out(SRww2) ; uart_blank() ;
	uart_crlf() ;
  //sleep_ms(1);
  //return ;

  cursorY=300-16*tftPos1 ;
  cursorX=320 ;
/*
  tftPos1++ ; if(tftPos1>=19){ tftPos1=0 ; }
  tftHexOut(SRgt) ; 
  tftBlank() ;
  tftWordOut(SRww1) ; tftBlank() ;
  tftWordOut(SRww2) ;
*/
  termCrlf() ;
  termHexOut(SRgt) ; 
  termBlank() ;
  termWordOut(SRww1) ; termBlank() ;
  termWordOut(SRww2) ;
 

  if (((SRww1 & 0x8000)==0) && ( (SRgt&0xf)==0 )) {
    timeGroup() ;
    }
  }

#define GPOL  0x1CF5 
#define BIT13 0x1000 
#define XN   0x19F3 

// 25 bit/sec
void doBBCbit(uint8_t the_bit){
  uint16_t cy50,cycrc,cyww1,cyww2 ;
  //uart_putc1(the_bit+'0') ;   
  local_time++ ;
  if (local_time == 50) { 
    local_time=0 ;
    if (seconds<60) { 
      seconds++ ; 
    	}
    }
  if (local_time == 25) { 
    if (seconds<60) { 
      seconds++ ; 
    	}
    }
  synced_time++ ;
  if ( local_time==sync_point) { synced_time=0 ; }
  if ( SRgt  & 0x10)   { cy50=1 ; } else { cy50=0 ; }
  if ( SRww1 & 0x8000) { cyww1=1 ; } else { cyww1=0 ; }
  if ( SRww2 & 0x8000) { cyww2=1 ; } else { cyww2=0 ; }
  if ( SRcrc & 0x1000) { cycrc=1 ; } else { cycrc=0 ; }

  SRgt =( SRgt  << 1) + cyww1 ;
  SRww1=( SRww1 << 1) + cyww2 ;
  SRww2=( SRww2 << 1) + cycrc ;
  SRcrc=((SRcrc << 1) + the_bit) & 0x1FFF ;

  if ( SRsyn & BIT13 ) { SRsyn=(SRsyn <<1) ^ GPOL ; } 
    else { SRsyn=SRsyn << 1 ; }
  SRsyn=(SRsyn ^ the_bit) & 0x1FFF ;

  if (cy50) { SRsyn ^= XN ; }

  if ( SRsyn==0x1283 ) { sm_do(0) ; }

  if ( ( synced_time==0) && (SRsyn!=0x1283) ) { 
    uart_putc1('-') ;
    }
  if ( ( synced_time==0) && (SRsyn==0x1283) ) { 
    uart_putc1('#') ;
    groupDecode() ;
    }
  }  

//----------------------------------------------------------------------------------------

int sin16[16]={0  ,38,71,92,100, 92, 71, 38,   0,-38,-71,-92,-100,-92,-71,-38} ;
int cos16[16]={100,92,71,38  ,0,-38,-71,-92,-100,-92,-71,-38,   0,38,71,92} ;

#define SAMPLECLK2 9

uint8_t ClockCorrection ;
uint8_t Clk16 ;
int Signal ;
int c16,s16 ;

int sLast=0 ;
#define eyeBufSize 1000
int eyeBufX1[eyeBufSize] ;
int eyeBufX2[eyeBufSize] ;
int eyeBufY1[eyeBufSize] ;
int eyeBufY2[eyeBufSize] ;
int eyeBufPtr=0 ;

void eyeInit(){
  sLast=0 ;
  eyeBufPtr=0 ;
  for(int k=0 ; k<eyeBufSize ; k++){
    eyeBufX1[k]=0 ;
    eyeBufX2[k]=0 ;
    eyeBufY1[k]=0 ;
    eyeBufY2[k]=0 ;
    }
  }

void doEye(int s){
  if(s>50) { s=50 ; }
  if(s<-50) { s=-50 ; }
  int color=0 ;
  int x1=40+12*(Clk16-1) ;
  int x2=40+12*Clk16 ;
  int y1=220+2*sLast ;
  int y2=220+2*s ;
  sLast=s ; 
  if (Clk16==SAMPLECLK2) { color=ILI9341_RED ; } else { color=ILI9341_WHITE ;  }
  tftLine(eyeBufX1[eyeBufPtr], eyeBufY1[eyeBufPtr], eyeBufX2[eyeBufPtr],eyeBufY2[eyeBufPtr],ILI9341_BLACK) ;
  eyeBufX1[eyeBufPtr]=x1 ;
  eyeBufX2[eyeBufPtr]=x2 ;
  eyeBufY1[eyeBufPtr]=y1 ;
  eyeBufY2[eyeBufPtr]=y2 ;
  eyeBufPtr++ ;
  if(eyeBufPtr>=eyeBufSize){ eyeBufPtr=0 ; }
  tftLine(x1, y1, x2,y2,color) ;
  }

void ClockPLL16(int16_t Signal){
  static int AbsSignal ;
  static int Isum,Qsum ;
  static int Count ;
  if (Signal<0) { AbsSignal=-Signal ; } else {  AbsSignal=Signal ; }
  c16=cos16[Clk16] ; 
  Isum += AbsSignal*c16 ;
  s16=sin16[Clk16] ; 
  Qsum += AbsSignal*s16 ;
  Count++ ;
  Count &= 63 ;
  if (Count==0){
    float ClockPhase=atan2(Qsum , Isum ) ;
    if (ClockPhase<0) { ClockCorrection= -1 ; } else { ClockCorrection=  1 ; }
    Isum=0 ;
  	Qsum=0 ;
	  }
  }

void doClkSample(){
  ClockPLL16(Signal) ;
  doEye(Signal) ;
  if ( ( Clk16==14 ) & (ClockCorrection |=0 ) )  {
    Clk16 += ClockCorrection ; 
	  ClockCorrection=0 ; 
	  }
  if  (Clk16==SAMPLECLK2) {
    if (Signal<0) { doBBCbit(1) ; } else { doBBCbit(0)  ; }
    }
  Clk16++ ;
  if (Clk16==16) { Clk16=0 ; }
  }

//----------------------------------------------------------------------------------------  

int CICfifoQout ;
int CICfifoIout ;
int EstimatedPhase ;
int OldPhase ;
int diff1 ;
int diff ;
int Qout ;
int DemodVal ;
uint8_t QmeanCount ;
int QmeanSum ;
int Qmean ;

int indexChar='A' ;
int nextFifoChk=0 ;

void doIQsample(){
  int Isample=IntFifoI[IntFifoOutPtr] ;
	int Qsample=IntFifoQ[IntFifoOutPtr] ;
  IntFifoOutPtr=(IntFifoOutPtr+1) & IntFifoMask ;

/*
  uart_putc1('s') ;
  if(indexChar<'Z') { indexChar++ ;} else { indexChar='A' ; }
  uart_putc1(indexChar) ;
  word_out(Isample) ;
  word_out(Qsample) ;
  uart_crlf() ;
  //return ;
  */

  // pwm_set_gpio_level(PWM_PIN, 62+Qsample/100000.0 );
  CICfifoQout = tprun(QQfil,Qsample)/500 ; 
  CICfifoIout = tprun(IIfil,Isample)/500 ; 
  // pwm_set_gpio_level(PWM_PIN, 62+CICfifoQout/30000.0 );
  //pwm_set_gpio_level(PWM_PIN1,62+CICfifoQout/30000.0 );
  //pwm_set_gpio_level(PWM_PIN2, 62+CICfifoIout/30000.0 );
  //EstimatedPhase=iCordic(CICfifoIout ,CICfifoQout ) ;
  EstimatedPhase=((int)(128/M_PI* atan2(CICfifoQout,CICfifoIout)))&0xFF ;
  // pwm_set_gpio_level(PWM_PIN, EstimatedPhase/2 );
	diff1=EstimatedPhase-OldPhase ;
  if(diff1>128){ diff1 -= 256 ; }
  if(diff1<-128){ diff1 +=256 ; }
	diff=diff1 ;
  OldPhase=EstimatedPhase ;
 
  Qout=10*tprun(demodFil,diff) ;
  QmeanSum += Qout ;
	QmeanCount += 1 ;
	if ( QmeanCount==0) {
	  Qmean=QmeanSum/256 ;
	  QmeanSum=0 ;
	  }
  DemodVal=Qout-Qmean ;
  Signal=DemodVal ;
  //zzz
  doClkSample() ;
  //zzz
  //pwm_set_gpio_level(PWM_PIN1, 62+Ival/50000.0 );
  pwm_set_gpio_level(PWM_PIN1, 250+EstimatedPhase );
  pwm_set_gpio_level(PWM_PIN2, 250+4*Qout );
  //zzz
 // pwm_set_gpio_level(PWM_PIN1, 250+2*CICfifoQout );
 // pwm_set_gpio_level(PWM_PIN2, 250+2*CICfifoIout );
  //zzz
  doScope(50+Qout) ;
  }


void PWMsetup(){    
  gpio_set_function(PWM_PIN1, GPIO_FUNC_PWM);
  gpio_set_function(PWM_PIN2, GPIO_FUNC_PWM);
  // Figure out which slice we just connected to the pin
  uint slice_num1 = pwm_gpio_to_slice_num(PWM_PIN1);
  uint slice_num2 = pwm_gpio_to_slice_num(PWM_PIN2);
  // Mask our slice's IRQ output into the PWM block's single interrupt line,
  // and register our interrupt handler
  pwm_clear_irq(slice_num1);
  pwm_set_irq_enabled(slice_num1, true);
  irq_set_exclusive_handler(PWM_IRQ_WRAP, on_pwm_wrap);
  irq_set_enabled(PWM_IRQ_WRAP, true);
  // Get some sensible defaults for the slice configuration. 
  pwm_config config1 = pwm_get_default_config();
  pwm_config config2 = pwm_get_default_config();
  // Set divider, reduces counter clock to sysclock/this value
  pwm_config_set_clkdiv(&config1, 1.f);
  pwm_config_set_clkdiv(&config2, 1.f);
  // Load the configuration into our PWM slice, and set it running.
  pwm_init(slice_num1, &config1, true);
  pwm_init(slice_num2, &config2, true);
  // Set period of 125 cycles (0 to 124 inclusive)
  //pwm_set_wrap(slice_num1,124 );
  #define clkDiv 500

  pwm_set_wrap(slice_num1,(clkDiv-1) );
  pwm_set_wrap(slice_num2,(clkDiv-1) );
  fPWM=125e6/clkDiv/1.0 ;
  printf("fPWM=%15.5f\n",fPWM) ;
  printf("PWM_PIN1=%d\n",PWM_PIN1) ;
  printf("slice_num1=%d\n",slice_num1) ;
  printf("config1=%d\n",config1) ;
  printf("\n") ;
  printf("PWM_PIN2=%d\n",PWM_PIN2) ;
  printf("slice_num2=%d\n",slice_num2) ;
  printf("config2=%d\n",config2) ;
  }

int kDown ;

void abort2(){
  printf("abort..\n") ;
  printf("\n") ;
  while(1){} ;
  }

void adcInit(void) {
  // ADC is in an unknown state. We should start by resetting it
  reset_block(RESETS_RESET_ADC_BITS);
  unreset_block_wait(RESETS_RESET_ADC_BITS);
  // Now turn it back on. Staging of clock etc is handled internally
  adc_hw->cs = ADC_CS_EN_BITS;
  // Internal staging completes in a few cycles, but poll to be sure
  while (!(adc_hw->cs & ADC_CS_READY_BITS)) {
    tight_loop_contents();
    }

  // Select ADC input 2 (GPIO28)
  adc_gpio_init(28);
  adc_select_input(2);

  adc_fifo_setup(true, false, 0, false, false);
  adc_run(true);

  // stop adc
  //adc_run(false);
  //adc_fifo_drain();
  }

int main() {
  stdio_init_all();
  gpio_init(GPIO4);
  gpio_set_dir(GPIO4, GPIO_OUT);
  
  tftSetup() ;
  termInit() ;


  PWMsetup() ;


  scopeInit() ;
  eyeInit ;
 
  start_syndrom() ;
 
  int fil1=butter(6,0.2) ;
  tpreset(fil1) ;
  //abort() ;
  demodFil=butter(2,40.0/800.0) ;
  IIfil=butter(2,50.0/800.0) ;
  QQfil=butter(2,50.0/800.0) ;

  approxSleepMs(200);
  printf("//\n") ;
  printf("//\n") ;
  printf("Hello IQmixBBCtoUartAsIQhex16v01 !\n") ;
  
  toggle=0 ;
   
  double DDSfrq=198000.0-0.6+1 ;
  printf("fSampleADC=%15d\n",fSampleADC) ;
  /*
  while(1){
    approxSleepMs(5);
    pwm_set_gpio_level(PWM_PIN, 5);
    sleep_ms(5);
    approxSleepMs(PWM_PIN, 100);
    }
  */
 
  adcInit();
  

  for(int k=0 ; k<256 ; k++){
    double phi=2*M_PI*k/256.0 ;
    sintab[k]=62+62*cos(phi) ;
    LOcosTab[k]=100*cos(phi) ;
    LOsinTab[k]=100*sin(phi) ;
    }

  DDSp =0 ;
  DDSd =0x2000000 ;  
  DDSd=(int)( 4294967296.0*DDSfrq/fSampleADC) ;
  // Everything after this point happens in the PWM interrupt handler, so we
  // can twiddle our thumbs

 // approxSleepUsTest() ;

  //IntFifoInit() ;
  if(0){
    int k1=0 ;
    while(1){
     // termPrintln("Hello World!") ;
      printf("Hello %d\n",k1++) ;
      }
    }  
  kDown=0 ;
  while (1){
    kDown++ ;
    if(kDown==250) {
      //printf("ph=%10d\n", EstimatedPhase) ; 
      //printf("%10d  %10d\n",CICfifoIout ,CICfifoQout) ;
     // printf("Qout=%8d\n",Qout) ;
      //printf("hello1\n") ;
      kDown=0 ;
      }

    if( IntFifoInPtr != IntFifoOutPtr ){
    //  gpio_put(GPIO4, 1);
	    doIQsample() ;
    //  gpio_put(GPIO4, 0);
      //toggle=1-toggle ;
      //if(toggle){ gpio_put(GPIO4, 1); } else { gpio_put(GPIO4, 0); }

	    }
    }
  }

